//=============================================================================
// WtypeUnless.js
//=============================================================================

/*:ja
 * @plugindesc ver1.01 必要武器の判定に改変を加えます。
 * @author まっつＵＰ
 * 
 * @help
 * 
 * RPGで笑顔を・・・
 * 
 * このヘルプとパラメータの説明をよくお読みになってからお使いください。
 * 
 * デフォルトの機能に「加え」、
 * 新たに必要武器を指定できます。
 * 
 * xには武器タイプIDを入れてください。
 * <WUaddmust:[x]>
 * <WUaddmust:[x,x]>
 * 
 * 例：<WUaddmust:[1,2]>
 * 新たに武器タイプ１または２をそのアクターが装備しているかの判定を加える。
 * 
 * 例：<WUaddmust:[0,1,2]>
 * 新たに武器タイプ１または２をそのアクターが装備しているかの判定を加える。
 * また、素手の時も使用できる。
 * (素手のために入れるこの0は必ず配列の0番目に入れてください。)
 * 
 * 
 * 利用規約(2022/04/08変更)：
 * この作品は マテリアル・コモンズ・ブルー・ライセンスの下に提供されています。
 * https://materialcommons.tk/mtcm-b-summary/
 * クレジット表示：まっつＵＰ
 * 
 */

(function () {

    //var parameters = PluginManager.parameters('WtypeUnless');

    Game_Actor.prototype.isSkillWtypeOk = function (skill) {
        var wtypeId1 = skill.requiredWtypeId1;
        var wtypeId2 = skill.requiredWtypeId2;
        if ((wtypeId1 === 0 && wtypeId2 === 0) ||
            (wtypeId1 > 0 && this.isWtypeEquipped(wtypeId1)) ||
            (wtypeId2 > 0 && this.isWtypeEquipped(wtypeId2)) ||
            (this.isWUaddmust(skill))) {
            return true;
        } else {
            return false;
        }
    };

    Game_Actor.prototype.isWUaddmust = function (skill) { //新規
        var WUadd = eval($dataSkills[skill.id].meta['WUaddmust'] || 0);
        //console.log(WUadd)
        if (WUadd) {
            if (this.hasNoWeapons() && WUadd[0] == 0) return true;
            for (var i = 0; i < WUadd.length; i++) {
                if (!this.isWtypeEquipped(WUadd[i])) continue;
                return true;
            }
        }
        return false; //メモがundefinedのときもここに来る。
    };

})();
